﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LinkedListClassLibrary
{
    public class SingleLinkedFloatList
    {
        private class ListeElement      // Skal kun bruges inde i vores liste klasse, derfor defineres inde i denne klasse og som private - den kan stadig ses i klassens scope
        {
            public float Data;
            public ListeElement NextElement;
            public ListeElement(float data, ListeElement nextElement=null)
            {
                this.Data = data;
                this.NextElement = nextElement;
            }
        }

        private ListeElement head = null;       // reference til starten på listen
        private ListeElement tail = null;       // reference til sidste element i listen


        // Opgave 1
        // Du skal programmere metoden så den opretter et nyt ListeElement med den værdi der angives i parameteren
        // Det nye liste element skal indsættes i listen så det er det første element i "kæden"
        // Du skal sikre at head og tail er korrekte efter metoden, samt at elementerne er "kædet" korrekt sammen
        public void InsertFirst(float data)
        {
            if (head == null)
            {
                ListeElement nyElm = new ListeElement(data);
                this.head = nyElm;
                this.tail = nyElm;
                //this.tail = this.head = new ListeElement(data);
            }
            //else if (this.head == this.tail)
            //{
            //    ListeElement nyElm = new ListeElement(data);
            //    this.head = nyElm;
            //    nyElm.NextElement = this.tail;
            //}
            else
            {
                ListeElement nyElm = new ListeElement(data);
                nyElm.NextElement = this.head;
                this.head = nyElm;
            }
            
//                throw new NotImplementedException();
        }

        // Opgave 2
        // Du skal programmere metoden så returnere true hvis listen er tom og ellers falsk
        public bool IsEmpty()
        {
            return (this.head==null);
        }

        // Opgave 3
        // Du skal programmere metoden så den fjerner første element i listen
        // Du skal sikre at head og tail er korrekte efter metoden, samt at elementerne er "kædet" korrekt sammen
        // Metoden skal returnere data fra det fjernede element
        // Hvis listen er tom skal metoden give en exception
        public float RemoveFirst()
        {
            ListeElement elm = this.head;
            if (this.head == this.tail)
            {
                this.head = null;
                this.tail = null;
            }
            else
            {
                this.head = this.head.NextElement;
            }
            return elm.Data;
            //            throw new NotImplementedException();
        }

        // Opgave 4
        // Du skal programmere metoden så den opretter et nyt ListeElement med den værdi der angives i parameteren
        // Det nye liste element skal indsættes i listen så det er det sidste element i "kæden"
        // Du skal sikre at head og tail er korrekte efter metoden, samt at elementerne er "kædet" korrekt sammen
        public void InsertLast(float data)
        {
            if (head == null)
            {
                ListeElement nyElm = new ListeElement(data);
                this.head = nyElm;
                this.tail = nyElm;
                //this.tail = this.head = new ListeElement(data);
            }
            else
            {
                ListeElement nyElm = new ListeElement(data);
                this.tail.NextElement = nyElm;
                this.tail = nyElm;
//                this.tail = this.tail.NextElement = new ListeElement(data);
            }
        }

        // Opgave 5
        // Du skal programmere metoden så den fjerner sidste element i listen
        // Du skal sikre at head og tail er korrekte efter metoden, samt at elementerne er "kædet" korrekt sammen
        // Metoden skal returnere data fra det fjernede element
        // Hvis listen er tom skal metoden give en exception
        // Bemærk denne er lidt mere kompliceret, idet du her også skal tænke på der nu er et andet element der bliver det sidste og
        // at det ikke skal "pege" på det der tidligere var sidst, men nu skal "pege" på ingen ting (null)
        public float RemoveLast()
        {
            throw new NotImplementedException();
        }

        // Opgave 6
        // Du skal programmere metoden så den returnerer data for elementer i listen på pladsen angivet med parameteren
        // Hvis elementet ikke findes (slut før den angivne position) skal metoden give en IndexOutOfRangeException
        // Første element defineres som værende position 0
        public float GetElementAt(int position)
        {
            throw new NotImplementedException();
        }


    }
}
